//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  eVXeݒ_CAO\
//  Windows Vistaȍ~p
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2011N0424 `
//
//  2011N1028
//    ENewStr֐֐֐ƂString^Ƃď悤ɂ(UnicodeΉ)
//    EWindows 7̃VXe֌W_CAO̎QlR[h啝ɒǉ
//    EShellExecuteExɓnpXtpXɂ
//
//  2013N0729
//    EpXt@CǂݍޕɕύX
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro, XE5(UP2) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit ShowDialog_SystemUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
    FCmdPath : string;
    FCmdPara : string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  ShellAPI,
  StrUtils;

{$R *.DFM}

//=============================================================================
//  tH[̏
//  ListBox1ɋNp̕Zbg
//
//  SystemDialogList.txtɂ́Cŏ̃J}܂łTListBoxɕ\镶
//  Ō܂łۂ̃pXƂ̃IvV֌W̕ƂȂ
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);

  //---------------------------------------------------------------------------
  //  ListBox1ɕƎsp̃pXZbg
  //---------------------------------------------------------------------------
  procedure AddItem(ACaption, APath: String);
  var
    LpAddStr : PString;
  begin
    New(LpAddStr);
    LpAddStr^ := APath;
    ListBox1.AddItem(ACaption, TObject(LpAddStr));
  end;
  //---------------------------------------------------------------------------

var
  LStringList : TStringList;
  LPos        : Integer;
  LStrCaption : string;
  LStrPath    : string;
  i           : Integer;
begin
  ListBox1.Sorted := True;

  //\p̕ƃpXi[t@Cǂݍŏ
  LStringList := TStringList.Create;
  try
    LStringList.LoadFromFile('SystemDialogList.txt');
    for i := 0 to LStringList.Count - 1 do begin
      LPos        := Pos(',', LStringList[i]);
      LStrCaption := Copy(LStringList[i], 1, LPos -1);
      LStrPath    := Trim(Copy(LStringList[i], LPos + 1, Length(LStringList[i])));

      //ListBox1Itemɒǉ
      AddItem(LStrCaption, LStrPath);
    end;
  finally
    FreeAndNil(LStringList);
  end;
  ListBox1.ItemIndex := 0;
  ListBox1Click(nil);
end;

//=============================================================================
//  tH[j̏
//  ListBox1̃IuWFNgj
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to ListBox1.Items.Count-1 do begin
    Dispose(PString(ListBox1.Items.Objects[i]));
  end;
end;

//=============================================================================
//  ListBox1OnDblClickCxg
//  ListBoxőIĂ_CAON
//=============================================================================
procedure TForm1.ListBox1DblClick(Sender: TObject);
var
  LRetCode : Integer;
begin
  if ListBox1.ItemIndex < 0 then exit;
  if FCmdPath = '' then exit;

  LRetCode := ShellExecute(Handle, '', PChar(FCmdPath), PChar(FCmdPara), nil, SW_SHOW);

  if LRetCode <=32 then begin
    MessageBox(Handle, PChar(SysErrorMessage(LRetCode)), '', MB_ICONINFORMATION);
  end;
end;

//=============================================================================
//  ListBox1OnClickCxg
//  IڂShellExecute֐ɓn̕쐬
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);

  //---------------------------------------------------------------------------
  //  ϐ܂(%̕܂)ۂ̃pXɕϊ
  //---------------------------------------------------------------------------
  function ExpandEnvironmentString(S: String): String;
  var
    LDstChar : array [0..MAX_PATH - 1] of Char;
  begin
    ExpandEnvironmentStrings(PChar(S), LDstChar, MAX_PATH);
    Result := LDstChar;
  end;
  //---------------------------------------------------------------------------

var
  LStringList : TStringList;
  LOriginCmd  : string;
  LEnvPath    : string;
begin
  if ListBox1.ItemIndex < 0 then exit;

  //I𒆂Items擾ăR}h쐬
  LOriginCmd := Trim(PString(ListBox1.Items.Objects[ListBox1.ItemIndex])^);
  LEnvPath   := ExpandEnvironmentString(LOriginCmd);

  //st@Cƃp[^ɕ
  LStringList := TStringList.Create;
  try
    LStringList.Delimiter       := ' ';
    LStringList.StrictDelimiter := True;
    LStringList.DelimitedText   := LEnvPath;

    if LStringList.Count = 1 then begin
      FCmdPath := Trim(LEnvPath);
      FCmdPara := '';
    end else begin
      FCmdPath := Trim(LStringList[0]);
      FCmdPara := Trim(StringReplace(LEnvPath, FCmdPath, '', [rfIgnoreCase]));
    end;
  finally
    FreeAndNil(LStringList);
  end;

  //pX̋󔒂܂łpXƔFĂ܂̂Ń_uNH[e[Vň͂
  //p[^͂̂܂܂Ƃ
  if Pos(' ', FCmdPath) > 1 then begin
    if LeftStr(FCmdPath, 1) <> '"' then begin
      FCmdPath := AnsiQuotedStr(FCmdPath, '"');
    end;
  end;
  Edit1.Text := LOriginCmd;
end;

//=============================================================================
//  ListBox1OnKeyDownCxg
//=============================================================================
procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ListBox1.ItemIndex < 0 then exit;

  if Key = VK_RETURN then begin
    ListBox1DblClick(nil);
    Key := 0;
  end;
end;

end.
